"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var webpack = require("webpack");
var path_1 = require("path");
module.exports = {
    entry: {
        vendor: ["./src/vendor.js"],
        hot: ['react-hot-loader/patch', 'webpack-hot-middleware/client']
    },
    output: {
        filename: '[name].js',
        path: path_1.resolve(process.cwd(), 'dist/'),
        // The name of the global variable which the library's
        // require() function will be assigned to
        library: '[name]_lib',
    },
    resolve: {
        extensions: ['.tsx', '.ts', '.js', '.css'],
        modules: ['node_modules', path_1.resolve(__dirname, "..", "node_modules")]
    },
    resolveLoader: {
        modules: ["node_modules", path_1.resolve(__dirname, "..", "node_modules")]
    },
    plugins: [
        new webpack.DllPlugin({
            // The path to the manifest file which maps between
            // modules included in a bundle and the internal IDs
            // within that bundle
            path: 'dist/[name]-manifest.json',
            // The name of the global variable which the library's
            // require function has been assigned to. This must match the
            // output.library option above
            name: '[name]_lib'
        }),
    ],
};
