"use strict";
// this file was authored by lith-light-g 
// see https://github.com/lith-light-g/universal-react-redux-typescript-starter-kit.git
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = require("path");
var webpack_1 = require("webpack");
var ExtractTextPlugin = require("extract-text-webpack-plugin");
exports.default = function (env) {
    var entry = {
        main: './src/index.tsx',
        vendor: './src/vendor.js',
    };
    // add hot module replacement if not in production
    entry = env !== 'production' ? __assign({ hot: ['react-hot-loader/patch', 'webpack-hot-middleware/client'] }, entry) : entry;
    // set devtool according to the environment
    var devtool = env === 'production' ? 'source-map' : 'eval-source-map';
    var plugins = [new webpack_1.optimize.CommonsChunkPlugin({
            names: ['vendor', 'common'],
        }), new ExtractTextPlugin('styles.css')];
    // set plugins hot module replacement plugins if not in production
    plugins = env === 'production' ? plugins.concat([
        new webpack_1.DefinePlugin({
            'process.env.NODE_ENV': JSON.stringify('production'),
        }),
        new webpack_1.LoaderOptionsPlugin({
            minimize: true,
            debug: false,
        }),
        new webpack_1.optimize.UglifyJsPlugin({
            compress: {
                screw_ie8: true,
                warnings: false,
            },
            sourceMap: true,
        }),
    ]) : plugins.concat([
        new webpack_1.HotModuleReplacementPlugin(),
        new webpack_1.NamedModulesPlugin(),
    ]);
    var cssRule = {
        test: /\.css$/,
        use: env === 'production' ?
            ExtractTextPlugin.extract(['css-loader', 'postcss-loader']) :
            ['style-loader', 'css-loader', 'postcss-loader'],
    };
    var appNodeModules = path_1.resolve(process.cwd(), "node_modules");
    return {
        entry: entry,
        stats: {
            errorDetails: true,
        },
        output: {
            filename: '[name].js',
            path: path_1.resolve(process.cwd(), 'dist', 'static'),
            publicPath: '/',
        },
        devtool: devtool,
        resolve: {
            extensions: ['.tsx', '.ts', '.js', '.css'],
            modules: ['node_modules', path_1.resolve(__dirname, "..", "node_modules")]
        },
        resolveLoader: {
            modules: ["node_modules", path_1.resolve(__dirname, "..", "node_modules")]
        },
        module: {
            rules: [
                {
                    test: /\.tsx?$/,
                    use: [
                        "react-hot-loader/webpack",
                        {
                            loader: 'awesome-typescript-loader',
                            options: {
                                configFileName: path_1.resolve(__dirname, "..", "tsconfig.json")
                            }
                        }
                    ],
                    exclude: /node_modules/,
                },
                cssRule,
            ],
        },
        plugins: plugins,
    };
};
