"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var path = require("path");
var watcher = require("./watch-for-root-component");
var webpack_dev_middleware_1 = require("./webpack-dev-middleware");
var middleware_factory_1 = require("./middleware-factory");
function factory(rootComponentPath, opts) {
    opts = opts || {};
    if (module.parent) {
        var fromDirname = path.dirname(module.parent.filename);
        if (!path.isAbsolute(rootComponentPath))
            rootComponentPath = path.resolve(fromDirname, rootComponentPath);
        if (opts.withRouter && !path.isAbsolute(opts.withRouter))
            opts.withRouter = path.resolve(fromDirname, opts.withRouter);
    }
    var env = process.env.NODE_ENV;
    var rootComponent = watcher.watch(rootComponentPath, function (updated) { return options.rootComponent = updated; });
    var routes = !!opts.withRouter ? watcher.watch(opts.withRouter, function (updated) { return options.routes = updated; }) : undefined;
    var includeJSFiles = env === 'production' ?
        ['common.js', 'vendor.js', 'main.js'] :
        ['common.js', 'vendor.js', 'hot.js', 'main.js'];
    var webpackDevHmrMiddleware = webpack_dev_middleware_1.default(env);
    var persistDataFactory = opts.persistDataFactory || (function () { return "undefined"; });
    var options = __assign({ rootComponent: rootComponent,
        routes: routes,
        env: env,
        webpackDevHmrMiddleware: webpackDevHmrMiddleware,
        includeJSFiles: includeJSFiles }, opts, { persistDataFactory: persistDataFactory });
    return middleware_factory_1.default(options);
}
module.exports = factory;
