"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var express = require("express");
var html_renderer_1 = require("./html-renderer");
function middlewareFactory(options) {
    var renderer = options.htmlRenderer ? options.htmlRenderer : html_renderer_1.defaultRenderer;
    var cRenderer = require(options.withRouter ? './render-component-with-router' : './render-component').default;
    return function middleware(req, rsp, next) {
        function ssr() {
            var persistedData = options.persistDataFactory();
            var rendered = cRenderer(options.rootComponent, req.url, persistedData, options.routes);
            if (rendered.redirect)
                return rsp.redirect(rendered.redirect);
            var html = renderer(rendered.contents, options.includeJSFiles, persistedData);
            rsp.send(html);
        }
        if (options.env === "production")
            express.static("dist/static")(req, rsp, ssr);
        else
            options.webpackDevHmrMiddleware(req, rsp, ssr);
    };
}
exports.default = middlewareFactory;
