"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var server_1 = require("react-dom/server");
var react_router_dom_1 = require("react-router-dom");
var react_router_config_1 = require("react-router-config");
exports.default = function (component, location, persistedData, routes) {
    var matched = react_router_config_1.matchRoutes(routes, location);
    var context = {};
    var routesElement = React.createElement(component, { persistedData: persistedData }, react_router_config_1.renderRoutes(routes));
    var rendered = React.createElement(react_router_dom_1.StaticRouter, { location: location, context: context }, routesElement);
    var contents = server_1.renderToString(rendered);
    return {
        redirect: context.url,
        contents: contents
    };
};
