"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var requireCacheSet = function () { return new Set(Object.keys(require.cache).filter(function (u) { return !u.match("node_modules"); })); };
Set.prototype.removeAll = function (values) {
    for (var next = values.next(); next.done != true; next = values.next())
        this.delete(next.value);
    return this;
};
function watch(filename, onChange) {
    var preCache = requireCacheSet();
    var required = require(filename).default;
    var newCache = requireCacheSet();
    var cache = Array.from(newCache.removeAll(preCache.values()));
    fs.watchFile(filename, function (curr, prev) {
        for (var _i = 0, cache_1 = cache; _i < cache_1.length; _i++) {
            var reqId = cache_1[_i];
            delete require.cache[reqId];
        }
        onChange(require(filename).default);
    });
    return required;
}
exports.watch = watch;
