"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var webpack = require("webpack");
var webpackDevMiddlewareFactory = require("webpack-dev-middleware");
var webpackHotMiddlewareFactory = require("webpack-hot-middleware");
var webpack_config_1 = require("../config/webpack.config");
function default_1(env) {
    var config = webpack_config_1.default(env);
    var compiler = webpack(config);
    var publicPath = config.output.publicPath;
    var webpackDevMiddleware = webpackDevMiddlewareFactory(compiler, {
        index: 'index.html',
        publicPath: publicPath,
        // quiet: true,
        stats: {
            colors: true,
        },
    });
    var webpackHotMiddleware = webpackHotMiddlewareFactory(compiler);
    return function (req, rsp, next) {
        webpackDevMiddleware(req, rsp, function () { return webpackHotMiddleware(req, rsp, next); });
    };
}
exports.default = default_1;
